void ui_call_mode_info_set(Boolean enabled, Array cursor_styles)
{
  UI_CALL(mode_info_set, enabled, cursor_styles);
}

void ui_call_update_menu(void)
{
  UI_CALL(update_menu);
}

void ui_call_busy_start(void)
{
  UI_CALL(busy_start);
}

void ui_call_busy_stop(void)
{
  UI_CALL(busy_stop);
}

void ui_call_mouse_on(void)
{
  UI_CALL(mouse_on);
}

void ui_call_mouse_off(void)
{
  UI_CALL(mouse_off);
}

void ui_call_mode_change(String mode, Integer mode_idx)
{
  UI_CALL(mode_change, mode, mode_idx);
}

void ui_call_bell(void)
{
  UI_CALL(bell);
}

void ui_call_visual_bell(void)
{
  UI_CALL(visual_bell);
}

void ui_call_flush(void)
{
  UI_CALL(flush);
}

void ui_call_suspend(void)
{
  UI_CALL(suspend);
}

void ui_call_set_title(String title)
{
  UI_CALL(set_title, title);
}

void ui_call_set_icon(String icon)
{
  UI_CALL(set_icon, icon);
}

void ui_call_option_set(String name, Object value)
{
  UI_CALL(option_set, name, value);
}

void ui_call_update_fg(Integer fg)
{
  Array args = ARRAY_DICT_INIT;
  ADD(args, INTEGER_OBJ(fg));
  UI_LOG(update_fg, 0);
  ui_event("update_fg", args);
}

void ui_call_update_bg(Integer bg)
{
  Array args = ARRAY_DICT_INIT;
  ADD(args, INTEGER_OBJ(bg));
  UI_LOG(update_bg, 0);
  ui_event("update_bg", args);
}

void ui_call_update_sp(Integer sp)
{
  Array args = ARRAY_DICT_INIT;
  ADD(args, INTEGER_OBJ(sp));
  UI_LOG(update_sp, 0);
  ui_event("update_sp", args);
}

void ui_call_resize(Integer width, Integer height)
{
  Array args = ARRAY_DICT_INIT;
  ADD(args, INTEGER_OBJ(width));
  ADD(args, INTEGER_OBJ(height));
  UI_LOG(resize, 0);
  ui_event("resize", args);
}

void ui_call_clear(void)
{
  Array args = ARRAY_DICT_INIT;
  UI_LOG(clear, 0);
  ui_event("clear", args);
}

void ui_call_eol_clear(void)
{
  Array args = ARRAY_DICT_INIT;
  UI_LOG(eol_clear, 0);
  ui_event("eol_clear", args);
}

void ui_call_cursor_goto(Integer row, Integer col)
{
  Array args = ARRAY_DICT_INIT;
  ADD(args, INTEGER_OBJ(row));
  ADD(args, INTEGER_OBJ(col));
  UI_LOG(cursor_goto, 0);
  ui_event("cursor_goto", args);
}

void ui_call_put(String str)
{
  Array args = ARRAY_DICT_INIT;
  ADD(args, STRING_OBJ(str));
  UI_LOG(put, 0);
  ui_event("put", args);
}

void ui_call_set_scroll_region(Integer top, Integer bot, Integer left, Integer right)
{
  Array args = ARRAY_DICT_INIT;
  ADD(args, INTEGER_OBJ(top));
  ADD(args, INTEGER_OBJ(bot));
  ADD(args, INTEGER_OBJ(left));
  ADD(args, INTEGER_OBJ(right));
  UI_LOG(set_scroll_region, 0);
  ui_event("set_scroll_region", args);
}

void ui_call_scroll(Integer count)
{
  Array args = ARRAY_DICT_INIT;
  ADD(args, INTEGER_OBJ(count));
  UI_LOG(scroll, 0);
  ui_event("scroll", args);
}

void ui_call_default_colors_set(Integer rgb_fg, Integer rgb_bg, Integer rgb_sp, Integer cterm_fg, Integer cterm_bg)
{
  UI_CALL(default_colors_set, rgb_fg, rgb_bg, rgb_sp, cterm_fg, cterm_bg);
}

void ui_call_hl_attr_define(Integer id, HlAttrs rgb_attrs, HlAttrs cterm_attrs, Array info)
{
  UI_CALL(hl_attr_define, id, rgb_attrs, cterm_attrs, info);
}

void ui_call_grid_resize(Integer grid, Integer width, Integer height)
{
  UI_CALL(grid_resize, grid, width, height);
}

void ui_call_grid_clear(Integer grid)
{
  UI_CALL(grid_clear, grid);
}

void ui_call_grid_cursor_goto(Integer grid, Integer row, Integer col)
{
  UI_CALL(grid_cursor_goto, grid, row, col);
}

void ui_call_grid_line(Integer grid, Integer row, Integer col_start, Array data)
{
  Array args = ARRAY_DICT_INIT;
  ADD(args, INTEGER_OBJ(grid));
  ADD(args, INTEGER_OBJ(row));
  ADD(args, INTEGER_OBJ(col_start));
  ADD(args, ARRAY_OBJ(data));
  UI_LOG(grid_line, 0);
  ui_event("grid_line", args);
}

void ui_call_grid_scroll(Integer grid, Integer top, Integer bot, Integer left, Integer right, Integer rows, Integer cols)
{
  UI_CALL(grid_scroll, grid, top, bot, left, right, rows, cols);
}

void ui_call_popupmenu_show(Array items, Integer selected, Integer row, Integer col)
{
  Array args = ARRAY_DICT_INIT;
  ADD(args, ARRAY_OBJ(items));
  ADD(args, INTEGER_OBJ(selected));
  ADD(args, INTEGER_OBJ(row));
  ADD(args, INTEGER_OBJ(col));
  UI_LOG(popupmenu_show, 0);
  ui_event("popupmenu_show", args);
}

void ui_call_popupmenu_hide(void)
{
  Array args = ARRAY_DICT_INIT;
  UI_LOG(popupmenu_hide, 0);
  ui_event("popupmenu_hide", args);
}

void ui_call_popupmenu_select(Integer selected)
{
  Array args = ARRAY_DICT_INIT;
  ADD(args, INTEGER_OBJ(selected));
  UI_LOG(popupmenu_select, 0);
  ui_event("popupmenu_select", args);
}

void ui_call_tabline_update(Tabpage current, Array tabs)
{
  Array args = ARRAY_DICT_INIT;
  ADD(args, TABPAGE_OBJ(current));
  ADD(args, ARRAY_OBJ(tabs));
  UI_LOG(tabline_update, 0);
  ui_event("tabline_update", args);
}

void ui_call_cmdline_show(Array content, Integer pos, String firstc, String prompt, Integer indent, Integer level)
{
  Array args = ARRAY_DICT_INIT;
  ADD(args, ARRAY_OBJ(content));
  ADD(args, INTEGER_OBJ(pos));
  ADD(args, STRING_OBJ(firstc));
  ADD(args, STRING_OBJ(prompt));
  ADD(args, INTEGER_OBJ(indent));
  ADD(args, INTEGER_OBJ(level));
  UI_LOG(cmdline_show, 0);
  ui_event("cmdline_show", args);
}

void ui_call_cmdline_pos(Integer pos, Integer level)
{
  Array args = ARRAY_DICT_INIT;
  ADD(args, INTEGER_OBJ(pos));
  ADD(args, INTEGER_OBJ(level));
  UI_LOG(cmdline_pos, 0);
  ui_event("cmdline_pos", args);
}

void ui_call_cmdline_special_char(String c, Boolean shift, Integer level)
{
  Array args = ARRAY_DICT_INIT;
  ADD(args, STRING_OBJ(c));
  ADD(args, BOOLEAN_OBJ(shift));
  ADD(args, INTEGER_OBJ(level));
  UI_LOG(cmdline_special_char, 0);
  ui_event("cmdline_special_char", args);
}

void ui_call_cmdline_hide(Integer level)
{
  Array args = ARRAY_DICT_INIT;
  ADD(args, INTEGER_OBJ(level));
  UI_LOG(cmdline_hide, 0);
  ui_event("cmdline_hide", args);
}

void ui_call_cmdline_block_show(Array lines)
{
  Array args = ARRAY_DICT_INIT;
  ADD(args, ARRAY_OBJ(lines));
  UI_LOG(cmdline_block_show, 0);
  ui_event("cmdline_block_show", args);
}

void ui_call_cmdline_block_append(Array lines)
{
  Array args = ARRAY_DICT_INIT;
  ADD(args, ARRAY_OBJ(lines));
  UI_LOG(cmdline_block_append, 0);
  ui_event("cmdline_block_append", args);
}

void ui_call_cmdline_block_hide(void)
{
  Array args = ARRAY_DICT_INIT;
  UI_LOG(cmdline_block_hide, 0);
  ui_event("cmdline_block_hide", args);
}

void ui_call_wildmenu_show(Array items)
{
  Array args = ARRAY_DICT_INIT;
  ADD(args, ARRAY_OBJ(items));
  UI_LOG(wildmenu_show, 0);
  ui_event("wildmenu_show", args);
}

void ui_call_wildmenu_select(Integer selected)
{
  Array args = ARRAY_DICT_INIT;
  ADD(args, INTEGER_OBJ(selected));
  UI_LOG(wildmenu_select, 0);
  ui_event("wildmenu_select", args);
}

void ui_call_wildmenu_hide(void)
{
  Array args = ARRAY_DICT_INIT;
  UI_LOG(wildmenu_hide, 0);
  ui_event("wildmenu_hide", args);
}

